From d7550aeeb233818d00f2607012c48ae3bd36ad76 Mon Sep 17 00:00:00 2001
From: anonym <anonym@riseup.net>
Date: Sat, 18 Mar 2017 16:40:33 +0100
Subject: [PATCH] Test suite: verifry that dirmngr used the configured
 keyserver.

Will-fix: #12371
---
 features/step_definitions/torified_gnupg.rb | 15 +++++++++++++++
 features/torified_gnupg.feature             |  1 +
 2 files changed, 16 insertions(+)

diff --git a/features/step_definitions/torified_gnupg.rb b/features/step_definitions/torified_gnupg.rb
index 74bd3a4cca..9543cccc7d 100644
--- a/features/step_definitions/torified_gnupg.rb
+++ b/features/step_definitions/torified_gnupg.rb
@@ -246,3 +246,18 @@ Given /^(GnuPG|Seahorse) is configured to use Chutney's onion keyserver$/ do |ap
     )
   end
 end
+
+Then /^GnuPG's dirmngr uses the configured keyserver$/ do
+  _, _, onion_keyserver_address, _ = chutney_onionservice_info
+  dirmngr_request = $vm.execute_successfully(
+    'gpg-connect-agent --dirmngr "keyserver --hosttable" /bye'
+  )
+  server = dirmngr_request.stdout.chomp.lines[1].split[4]
+  server = /keyserver\s+(\S+)$/.match(
+    $vm.file_content("/home/#{LIVE_USER}/.gnupg/dirmngr.conf")
+  )[1]
+  assert_equal(
+    "hkp://#{onion_keyserver_address}", server,
+    "GnuPG's dirmngr does not use the correct keyserver"
+  )
+end
diff --git a/features/torified_gnupg.feature b/features/torified_gnupg.feature
index fedb503a26..67c338ff32 100644
--- a/features/torified_gnupg.feature
+++ b/features/torified_gnupg.feature
@@ -15,6 +15,7 @@ Feature: Keyserver interaction with GnuPG
     When I fetch the "10CC5BC7" OpenPGP key using the GnuPG CLI
     And the GnuPG fetch is successful
     Then the "10CC5BC7" key is in the live user's public keyring
+    And GnuPG's dirmngr uses the configured keyserver
 
   Scenario: Fetching OpenPGP keys using Seahorse should work and be done over Tor.
     When I fetch the "10CC5BC7" OpenPGP key using Seahorse
-- 
2.11.0

